local GF = {
	Event = {},
	data = {
		playerID = "",
		update = false,
		firstCall = 0.0,
		meter_x = 0,
		meter_y = 0,
		startCash=0,
		sessionStart =0,
	},
	 
}




function GF.Event.LoadEnd(identifier)
	if identifier == "GoldFarmer" then
		
		GF.data.playerID = Inspect.Unit.Lookup("player")
		GF.data.sessionStart = Inspect.Time.Real()
		GF.data.startCash = Inspect.Currency.Detail("coin").stack
		GF.data.update = true
		print("GoldFarmer loaded. /GF")
	end
end


function GF.Event.SlashHandler(str)
	
	local cmd, arg = string.match(str, "(%a+) ?(.*)")

		print("Slash Commands:")
		
	end
	

local function AddDragFrame(window)

  function window.Event:LeftDown()
    self.leftDown = true
    local mouse = Inspect.Mouse()
    self.originalXDiff = mouse.x - self:GetLeft()
    self.originalYDiff = mouse.y - self:GetTop()
    local left, top, right, bottom = window:GetBounds()
    window:ClearAll()
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
    window:SetWidth(right-left)
    window:SetHeight(bottom-top)
  end

  function window.Event:LeftUp()
    self.leftDown = false
  end

  function window.Event:LeftUpoutside()
    self.leftDown = false
  end

  function window.Event:MouseMove(x, y)
    if not self.leftDown then
      return
    end
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, y - self.originalYDiff)
	GF.data.meter_x = x - self.originalXDiff
	GF.data.meter_y = y - self.originalYDiff
  end
end

-- start frames
local main = UI.CreateContext("UI")
local box = UI.CreateFrame("Frame", "box", main)
local ticker = UI.CreateFrame("Text", "Ticker", box)
local icon = UI.CreateFrame("Texture", "Icon", main)



box:SetPoint("TOPLEFT",UIParent,"TOPLEFT",100,100)
box:SetWidth(115)
box:SetHeight(25)
box:SetAlpha(.6)
box:SetVisible(true)
box:SetBackgroundColor(0,0,0)
box:SetLayer(1)

ticker:SetText("0")
ticker:SetPoint("TOPRIGHT",box,"TOPRIGHT",0,0)
ticker:SetFontSize(20)
ticker:SetLayer(2)

icon:SetPoint("TOPLEFT",box,"TOPLEFT",0,0)
icon:SetWidth(15)
icon:SetHeight(25)
icon:SetAlpha(1)
icon:SetVisible(true)
icon:SetTexture("GoldFarmer", "time.PNG")
icon:SetLayer(2)

local lastCall = Inspect.Time.Real()

function fade()
if GF.data.update then
if GF.data.startCash == nil then GF.data.startCash = Inspect.Currency.Detail("coin").stack return end

if GF.data.sessionStart == nil then GF.data.sessionStart = Inspect.Time.Real() return end

local now = Inspect.Time.Real()
	if (now<lastCall+.6) then 
		return
	end
	
local sessionLen = (now - GF.data.sessionStart)/60
local nowCash = Inspect.Currency.Detail("coin").stack
if nowCash == nil then return end

local income = (nowCash - GF.data.startCash) / 100

ticker:SetText(tostring(math.floor((income / sessionLen)*100)/100))
--ticker:SetText(tostring(math.floor(sessionLen)))
--ticker:SetText(tostring(Inspect.Currency.Detail("coin").stack / 100))
lastCall = now

end
end


local function GFsave()
 	 
meter_x = GF.data.meter_x
meter_y = GF.data.meter_y

   end


local function GFload()

if meter_x then
GF.data.meter_x = tonumber(meter_x)
end

if meter_y then
 GF.data.meter_y = tonumber(meter_y)
 end


--fade()
box:ClearAll()
box:SetPoint("TOPLEFT", main, "TOPLEFT", GF.data.meter_x, GF.data.meter_y)
box:SetWidth(100)
box:SetHeight(25)


   end
	
	AddDragFrame(box)
--table.insert(Event.Currency, {fade, "GoldFarmer", "fade"})
table.insert(Event.System.Update.Begin, {fade, "GoldFarmer", "fade"})


table.insert(Event.Addon.SavedVariables.Save.Begin, {GFsave, "GoldFarmer", "Save variables"})
table.insert(Event.Addon.SavedVariables.Load.End, {GFload, "GoldFarmer", "Load variables"})
table.insert(Event.Addon.Load.End, 				{GF.Event.LoadEnd, 			"GoldFarmer", "Init"})
table.insert(Command.Slash.Register("GF"), 		{GF.Event.SlashHandler, 	"GoldFarmer", "Slash"})